cat > doc/Makefile << EOT
#  This file was created by Configure. Any change made to it will be lost
#  next time configure is run.
#
SHELL = $make_sh

doc all: manual refcard tutorial
docps: refcard.ps tutorial.ps users.ps
manual: users.dvi
tutorial: tutorial.dvi

macros.tex: macros.tex.in
	sed -e 's/@version@/$version.$patch/'\\
	    -e 's!@miscdir@!/usr/local/lib/pari!' macros.tex.in > \$@

tutorial.dvi: tutorial.tex macros.tex
	tex tutorial.tex

refcard: refcard.ps

refcard.dvi: refcard.tex macros.tex
	tex refcard.tex

refcard.ps: refcard.dvi
	dvips -t landscape -t a4 refcard.dvi -o \$@

users.ps: users.dvi
	dvips users.dvi -o \$@

tutorial.ps: tutorial.dvi
	dvips tutorial.dvi -o \$@

users.dvi: users.tex appa.tex appb.tex appc.tex\\
 usersch1.tex usersch2.tex usersch3.tex usersch4.tex usersch5.tex\\
 macros.tex macrosbig.tex
	rm -f users.std; tex users;
	sed -e 's/!\([1-9]\)!/!00\1!/'\\
	    -e 's/!\([1-9][0-9]\)!/!0\1!/'\\
	    -e 's/[{][}]//'\\
	  users.idx | sort -f |\\
	sed -e 's/!0*\([0-9]*\)!/!\1!/' > users.std;
	tex users; rm -f users.idx

gpman: gp.1
	nroff -man gp.1 | unix2dos -ascii > gp.man

halfclean:	
	rm -f *.log *.dvi *.idx *.ps tutorial.aux

clean: halfclean	
	rm -f users.aux users.std users.toc

veryclean: clean
	rm -f macros.tex gp.man
EOT
